<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.17"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>CS 250 Data Structures: DataStructure/BinarySearchTree/BinarySearchTree.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">CS 250 Data Structures
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.17 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_61f8caed08096df072032ac640f6feca.html">DataStructure</a></li><li class="navelem"><a class="el" href="dir_6ca12d504933556f9ebd2078a6fff522.html">BinarySearchTree</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">BinarySearchTree.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="BinarySearchTree_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="preprocessor">#ifndef _BINARY_SEARCH_TREE_HPP</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="preprocessor">#define _BINARY_SEARCH_TREE_HPP</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160; </div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment">// Project includes</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="BinarySearchTreeNode_8h.html">BinarySearchTreeNode.h</a>&quot;</span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#include &quot;../../Utilities/Logger.h&quot;</span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#include &quot;../../Utilities/StringUtil.h&quot;</span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160; </div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#include &lt;stdexcept&gt;</span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="keyword">using namespace </span>std;</div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160; </div>
<div class="line"><a name="l00012"></a><span class="lineno"><a class="line" href="namespaceDataStructure.html">   12</a></span>&#160;<span class="keyword">namespace </span><a class="code" href="namespaceDataStructure.html">DataStructure</a></div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;{</div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160; </div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> TK, <span class="keyword">typename</span> TD&gt;</div>
<div class="line"><a name="l00017"></a><span class="lineno"><a class="line" href="classDataStructure_1_1BinarySearchTree.html">   17</a></span>&#160;<span class="keyword">class </span><a class="code" href="classDataStructure_1_1BinarySearchTree.html">BinarySearchTree</a></div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;{</div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="keyword">private</span>:</div>
<div class="line"><a name="l00021"></a><span class="lineno"><a class="line" href="classDataStructure_1_1BinarySearchTree.html#a3c6a9c70728ff0309cbcc02d47c06433">   21</a></span>&#160;    <a class="code" href="classDataStructure_1_1BinarySearchTreeNode.html">BinarySearchTreeNode&lt;TK, TD&gt;</a>* <a class="code" href="classDataStructure_1_1BinarySearchTree.html#a3c6a9c70728ff0309cbcc02d47c06433">m_ptrRoot</a>;</div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160; </div>
<div class="line"><a name="l00024"></a><span class="lineno"><a class="line" href="classDataStructure_1_1BinarySearchTree.html#a483543c8214d622bb7b820ba23b40df6">   24</a></span>&#160;    <span class="keywordtype">int</span> <a class="code" href="classDataStructure_1_1BinarySearchTree.html#a483543c8214d622bb7b820ba23b40df6">m_nodeCount</a>;</div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160; </div>
<div class="line"><a name="l00027"></a><span class="lineno"><a class="line" href="classDataStructure_1_1BinarySearchTree.html#a4f901b67b9d1a83f0c3be784eead987e">   27</a></span>&#160;    <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classDataStructure_1_1BinarySearchTreeTester.html">BinarySearchTreeTester</a>;</div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160; </div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;    <a class="code" href="classDataStructure_1_1BinarySearchTree.html">BinarySearchTree</a>();</div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;    ~<a class="code" href="classDataStructure_1_1BinarySearchTree.html">BinarySearchTree</a>();</div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160; </div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;    <span class="comment">// Basic functionality</span></div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;<span class="comment"></span>    <span class="keywordtype">void</span> Push( <span class="keyword">const</span> TK&amp; newKey, <span class="keyword">const</span> TD&amp; newData );</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;    <span class="keywordtype">bool</span> Contains( <span class="keyword">const</span> TK&amp; key );</div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;    TD&amp; GetData( <span class="keyword">const</span> TK&amp; key );</div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160; </div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;    TD&amp; GetRoot();</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;    <span class="keywordtype">void</span> PopRoot();</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;    <span class="keywordtype">void</span> ShiftNodes(<a class="code" href="classDataStructure_1_1BinarySearchTreeNode.html">BinarySearchTreeNode&lt;TK, TD&gt;</a>* node1, <a class="code" href="classDataStructure_1_1BinarySearchTreeNode.html">BinarySearchTreeNode&lt;TK, TD&gt;</a>* node2);</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160; </div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;    <span class="comment">// Traversal functions</span></div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;<span class="comment"></span>    std::string GetInOrder();</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;    std::string GetPreOrder();</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;    std::string GetPostOrder();</div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160; </div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;    <span class="comment">// Additional functionality</span></div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;<span class="comment"></span>    TK&amp; GetMinKey();</div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;    TK&amp; GetMaxKey();</div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;    <span class="keywordtype">int</span> GetHeight();</div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;    <span class="keywordtype">int</span> GetCount();</div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160; </div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;    <span class="comment">//    void Delete( const TK&amp; key );</span></div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160; </div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;<span class="keyword">private</span>:</div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;    <a class="code" href="classDataStructure_1_1BinarySearchTreeNode.html">BinarySearchTreeNode&lt;TK, TD&gt;</a>* FindNode( <span class="keyword">const</span> TK&amp; key );</div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160; </div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;    <span class="comment">// Recursive traversal functions</span></div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;<span class="comment"></span>    <span class="keywordtype">void</span> RecursiveGetInOrder  ( <a class="code" href="classDataStructure_1_1BinarySearchTreeNode.html">BinarySearchTreeNode&lt;TK, TD&gt;</a>* ptrCurrent, std::stringstream&amp; stream );</div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;    <span class="keywordtype">void</span> RecursiveGetPreOrder ( <a class="code" href="classDataStructure_1_1BinarySearchTreeNode.html">BinarySearchTreeNode&lt;TK, TD&gt;</a>* ptrCurrent, std::stringstream&amp; stream );</div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;    <span class="keywordtype">void</span> RecursiveGetPostOrder( <a class="code" href="classDataStructure_1_1BinarySearchTreeNode.html">BinarySearchTreeNode&lt;TK, TD&gt;</a>* ptrCurrent, std::stringstream&amp; stream );</div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160; </div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;    <span class="comment">// Recursive additional functionality</span></div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;<span class="comment"></span>    <a class="code" href="classDataStructure_1_1BinarySearchTreeNode.html">BinarySearchTreeNode&lt;TK, TD&gt;</a>* RecursiveFindNode( <span class="keyword">const</span> TK&amp; key, <a class="code" href="classDataStructure_1_1BinarySearchTreeNode.html">BinarySearchTreeNode&lt;TK, TD&gt;</a>* ptrCurrent );</div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;    <a class="code" href="classDataStructure_1_1BinarySearchTreeNode.html">BinarySearchTreeNode&lt;TK, TD&gt;</a>* RecursiveGetMax( <a class="code" href="classDataStructure_1_1BinarySearchTreeNode.html">BinarySearchTreeNode&lt;TK, TD&gt;</a>* ptrCurrent );</div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;    <a class="code" href="classDataStructure_1_1BinarySearchTreeNode.html">BinarySearchTreeNode&lt;TK, TD&gt;</a>* RecursiveGetMin( <a class="code" href="classDataStructure_1_1BinarySearchTreeNode.html">BinarySearchTreeNode&lt;TK, TD&gt;</a>* ptrCurrent );</div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;    <span class="keywordtype">int</span> RecursiveGetHeight( <a class="code" href="classDataStructure_1_1BinarySearchTreeNode.html">BinarySearchTreeNode&lt;TK, TD&gt;</a>* ptrCurrent );</div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;    <span class="keywordtype">bool</span> RecursiveContains( <span class="keyword">const</span> TK&amp; key, <a class="code" href="classDataStructure_1_1BinarySearchTreeNode.html">BinarySearchTreeNode&lt;TK, TD&gt;</a>* ptrCurrent );</div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;    <span class="keywordtype">void</span> RecursivePush( <span class="keyword">const</span> TK&amp; newKey, <span class="keyword">const</span> TD&amp; newData, <a class="code" href="classDataStructure_1_1BinarySearchTreeNode.html">BinarySearchTreeNode&lt;TK, TD&gt;</a>* ptrCurrent );</div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160; </div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;    <span class="keywordtype">void</span> PopNode(<a class="code" href="classDataStructure_1_1BinarySearchTreeNode.html">BinarySearchTreeNode&lt;TK, TD&gt;</a>* ptrCurrent);</div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160; </div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;    <a class="code" href="classDataStructure_1_1BinarySearchTreeNode.html">BinarySearchTreeNode&lt;TK, TD&gt;</a>* GetSuccessor(<a class="code" href="classDataStructure_1_1BinarySearchTreeNode.html">BinarySearchTreeNode&lt;TK, TD&gt;</a>* ptrCurrent);</div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160; </div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;};</div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160; </div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;<span class="comment">/* **************************************************************************************** */</span></div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;<span class="comment">/* ******************************************************************* Function definitions */</span></div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;<span class="comment">/* **************************************************************************************** */</span></div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160; </div>
<div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> TK, <span class="keyword">typename</span> TD&gt;</div>
<div class="line"><a name="l00112"></a><span class="lineno"><a class="line" href="classDataStructure_1_1BinarySearchTree.html#ab5814e0a82125eafc6f40fd84f793eb4">  112</a></span>&#160;<a class="code" href="classDataStructure_1_1BinarySearchTree.html">BinarySearchTree&lt;TK,TD&gt;::BinarySearchTree</a>()</div>
<div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;{</div>
<div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;    <a class="code" href="classUtility_1_1Logger.html#a084fbcd19701dc0b69c7549bef4c667f">Utility::Logger::OutHighlight</a>( <span class="stringliteral">&quot;FUNCTION BEGIN&quot;</span>, <span class="stringliteral">&quot;BinarySearchTree&lt;TK,TD&gt; Constructor&quot;</span> );</div>
<div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;    m_ptrRoot = <span class="keyword">nullptr</span>;</div>
<div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;    m_nodeCount = 0;</div>
<div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;}</div>
<div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160; </div>
<div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160; </div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> TK, <span class="keyword">typename</span> TD&gt;</div>
<div class="line"><a name="l00124"></a><span class="lineno"><a class="line" href="classDataStructure_1_1BinarySearchTree.html#a2470cabc162d697002447db1cb85dc8b">  124</a></span>&#160;<a class="code" href="classDataStructure_1_1BinarySearchTree.html">BinarySearchTree&lt;TK,TD&gt;::~BinarySearchTree</a>()</div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;{</div>
<div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;    <a class="code" href="classUtility_1_1Logger.html#a084fbcd19701dc0b69c7549bef4c667f">Utility::Logger::OutHighlight</a>( <span class="stringliteral">&quot;FUNCTION BEGIN&quot;</span>, <span class="stringliteral">&quot;BinarySearchTree&lt;TK,TD&gt; Destructor&quot;</span> );</div>
<div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;    <span class="keywordflow">if</span> ( m_ptrRoot != <span class="keyword">nullptr</span> )</div>
<div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;    {</div>
<div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;        <span class="keyword">delete</span> m_ptrRoot;</div>
<div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;    }</div>
<div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;}</div>
<div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160; </div>
<div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160; </div>
<div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> TK, <span class="keyword">typename</span> TD&gt;</div>
<div class="line"><a name="l00145"></a><span class="lineno"><a class="line" href="classDataStructure_1_1BinarySearchTree.html#a1539ce01efd9c9a6c1b83c2b0ca6b6f3">  145</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classDataStructure_1_1BinarySearchTree.html">BinarySearchTree&lt;TK,TD&gt;::Push</a>( <span class="keyword">const</span> TK&amp; newKey, <span class="keyword">const</span> TD&amp; newData )</div>
<div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;{</div>
<div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;    <span class="keywordflow">throw</span> <a class="code" href="classException_1_1NotImplementedException.html">Exception::NotImplementedException</a>( <span class="stringliteral">&quot;Push&quot;</span> ); <span class="comment">// Erase this once you work on this function</span></div>
<div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;}</div>
<div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160; </div>
<div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160; </div>
<div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> TK, <span class="keyword">typename</span> TD&gt;</div>
<div class="line"><a name="l00175"></a><span class="lineno"><a class="line" href="classDataStructure_1_1BinarySearchTree.html#a9a70833be0a466064fa47b00a1d618af">  175</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classDataStructure_1_1BinarySearchTree.html">BinarySearchTree&lt;TK,TD&gt;::RecursivePush</a>( <span class="keyword">const</span> TK&amp; newKey, <span class="keyword">const</span> TD&amp; newData, <a class="code" href="classDataStructure_1_1BinarySearchTreeNode.html">BinarySearchTreeNode&lt;TK, TD&gt;</a>* ptrCurrent )</div>
<div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;{</div>
<div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;    <span class="keywordflow">throw</span> <a class="code" href="classException_1_1NotImplementedException.html">Exception::NotImplementedException</a>( <span class="stringliteral">&quot;RecursivePush&quot;</span> ); <span class="comment">// Erase this once you work on this function</span></div>
<div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;}</div>
<div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160; </div>
<div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> TK, <span class="keyword">typename</span> TD&gt;</div>
<div class="line"><a name="l00187"></a><span class="lineno"><a class="line" href="classDataStructure_1_1BinarySearchTree.html#adab16db3a643345ac73548d01f5a5fdf">  187</a></span>&#160;<span class="keywordtype">bool</span> <a class="code" href="classDataStructure_1_1BinarySearchTree.html">BinarySearchTree&lt;TK,TD&gt;::Contains</a>( <span class="keyword">const</span> TK&amp; key )</div>
<div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;{</div>
<div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;    <span class="keywordflow">throw</span> <a class="code" href="classException_1_1NotImplementedException.html">Exception::NotImplementedException</a>( <span class="stringliteral">&quot;Contains&quot;</span> ); <span class="comment">// Erase this once you work on this function</span></div>
<div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;}</div>
<div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160; </div>
<div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> TK, <span class="keyword">typename</span> TD&gt;</div>
<div class="line"><a name="l00211"></a><span class="lineno"><a class="line" href="classDataStructure_1_1BinarySearchTree.html#a6a049f530dd6ac0211ef33c0a3b79cd5">  211</a></span>&#160;<span class="keywordtype">bool</span> <a class="code" href="classDataStructure_1_1BinarySearchTree.html">BinarySearchTree&lt;TK,TD&gt;::RecursiveContains</a>( <span class="keyword">const</span> TK&amp; key, <a class="code" href="classDataStructure_1_1BinarySearchTreeNode.html">BinarySearchTreeNode&lt;TK, TD&gt;</a>* ptrCurrent )</div>
<div class="line"><a name="l00212"></a><span class="lineno">  212</span>&#160;{</div>
<div class="line"><a name="l00213"></a><span class="lineno">  213</span>&#160;    <span class="keywordflow">throw</span> <a class="code" href="classException_1_1NotImplementedException.html">Exception::NotImplementedException</a>( <span class="stringliteral">&quot;RecursiveContains&quot;</span> ); <span class="comment">// Erase this once you work on this function</span></div>
<div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;}</div>
<div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160; </div>
<div class="line"><a name="l00233"></a><span class="lineno">  233</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> TK, <span class="keyword">typename</span> TD&gt;</div>
<div class="line"><a name="l00234"></a><span class="lineno"><a class="line" href="classDataStructure_1_1BinarySearchTree.html#a2cefdf57e6cd5eee93fe83240a06224e">  234</a></span>&#160;<a class="code" href="classDataStructure_1_1BinarySearchTreeNode.html">BinarySearchTreeNode&lt;TK, TD&gt;</a>* <a class="code" href="classDataStructure_1_1BinarySearchTree.html">BinarySearchTree&lt;TK,TD&gt;::RecursiveFindNode</a>( <span class="keyword">const</span> TK&amp; key, <a class="code" href="classDataStructure_1_1BinarySearchTreeNode.html">BinarySearchTreeNode&lt;TK, TD&gt;</a>* ptrCurrent )</div>
<div class="line"><a name="l00235"></a><span class="lineno">  235</span>&#160;{</div>
<div class="line"><a name="l00236"></a><span class="lineno">  236</span>&#160;    <span class="keywordflow">throw</span> <a class="code" href="classException_1_1NotImplementedException.html">Exception::NotImplementedException</a>( <span class="stringliteral">&quot;RecursiveFindNode&quot;</span> ); <span class="comment">// Erase this once you work on this function</span></div>
<div class="line"><a name="l00237"></a><span class="lineno">  237</span>&#160;}</div>
<div class="line"><a name="l00238"></a><span class="lineno">  238</span>&#160; </div>
<div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> TK, <span class="keyword">typename</span> TD&gt;</div>
<div class="line"><a name="l00245"></a><span class="lineno"><a class="line" href="classDataStructure_1_1BinarySearchTree.html#a413cb728337d1aacb29fac517dc78962">  245</a></span>&#160;std::string <a class="code" href="classDataStructure_1_1BinarySearchTree.html">BinarySearchTree&lt;TK,TD&gt;::GetInOrder</a>()</div>
<div class="line"><a name="l00246"></a><span class="lineno">  246</span>&#160;{</div>
<div class="line"><a name="l00247"></a><span class="lineno">  247</span>&#160;<span class="comment">//    Utility::Logger::OutHighlight( &quot;FUNCTION BEGIN&quot;, &quot;BinarySearchTree&lt;TK,TD&gt;::GetInOrder&quot; );</span></div>
<div class="line"><a name="l00248"></a><span class="lineno">  248</span>&#160;    std::stringstream stream;</div>
<div class="line"><a name="l00249"></a><span class="lineno">  249</span>&#160;    RecursiveGetInOrder( m_ptrRoot, stream );</div>
<div class="line"><a name="l00250"></a><span class="lineno">  250</span>&#160;    <span class="keywordflow">return</span> stream.str();</div>
<div class="line"><a name="l00251"></a><span class="lineno">  251</span>&#160;}</div>
<div class="line"><a name="l00252"></a><span class="lineno">  252</span>&#160; </div>
<div class="line"><a name="l00262"></a><span class="lineno">  262</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> TK, <span class="keyword">typename</span> TD&gt;</div>
<div class="line"><a name="l00263"></a><span class="lineno"><a class="line" href="classDataStructure_1_1BinarySearchTree.html#a52a75668c7c7fe86cb2523a122c4fa1f">  263</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classDataStructure_1_1BinarySearchTree.html">BinarySearchTree&lt;TK,TD&gt;::RecursiveGetInOrder</a>( <a class="code" href="classDataStructure_1_1BinarySearchTreeNode.html">BinarySearchTreeNode&lt;TK, TD&gt;</a>* ptrCurrent, std::stringstream&amp; stream )</div>
<div class="line"><a name="l00264"></a><span class="lineno">  264</span>&#160;{</div>
<div class="line"><a name="l00265"></a><span class="lineno">  265</span>&#160;    <span class="keywordflow">throw</span> <a class="code" href="classException_1_1NotImplementedException.html">Exception::NotImplementedException</a>( <span class="stringliteral">&quot;RecursiveGetInOrder&quot;</span> ); <span class="comment">// Erase this once you work on this function</span></div>
<div class="line"><a name="l00266"></a><span class="lineno">  266</span>&#160;}</div>
<div class="line"><a name="l00267"></a><span class="lineno">  267</span>&#160; </div>
<div class="line"><a name="l00273"></a><span class="lineno">  273</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> TK, <span class="keyword">typename</span> TD&gt;</div>
<div class="line"><a name="l00274"></a><span class="lineno"><a class="line" href="classDataStructure_1_1BinarySearchTree.html#a6331270db8ac855cb6d71bf64c3a2376">  274</a></span>&#160;std::string <a class="code" href="classDataStructure_1_1BinarySearchTree.html">BinarySearchTree&lt;TK,TD&gt;::GetPreOrder</a>()</div>
<div class="line"><a name="l00275"></a><span class="lineno">  275</span>&#160;{</div>
<div class="line"><a name="l00276"></a><span class="lineno">  276</span>&#160;<span class="comment">//    Utility::Logger::OutHighlight( &quot;FUNCTION BEGIN&quot;, &quot;BinarySearchTree&lt;TK,TD&gt;::GetPreOrder&quot; );</span></div>
<div class="line"><a name="l00277"></a><span class="lineno">  277</span>&#160;    std::stringstream stream;</div>
<div class="line"><a name="l00278"></a><span class="lineno">  278</span>&#160;    RecursiveGetPreOrder( m_ptrRoot, stream );</div>
<div class="line"><a name="l00279"></a><span class="lineno">  279</span>&#160;    <span class="keywordflow">return</span> stream.str();</div>
<div class="line"><a name="l00280"></a><span class="lineno">  280</span>&#160;}</div>
<div class="line"><a name="l00281"></a><span class="lineno">  281</span>&#160; </div>
<div class="line"><a name="l00291"></a><span class="lineno">  291</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> TK, <span class="keyword">typename</span> TD&gt;</div>
<div class="line"><a name="l00292"></a><span class="lineno"><a class="line" href="classDataStructure_1_1BinarySearchTree.html#a545f1a837f79216bb66d9cfd9abd5724">  292</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classDataStructure_1_1BinarySearchTree.html">BinarySearchTree&lt;TK,TD&gt;::RecursiveGetPreOrder</a>( <a class="code" href="classDataStructure_1_1BinarySearchTreeNode.html">BinarySearchTreeNode&lt;TK, TD&gt;</a>* ptrCurrent, std::stringstream&amp; stream )</div>
<div class="line"><a name="l00293"></a><span class="lineno">  293</span>&#160;{</div>
<div class="line"><a name="l00294"></a><span class="lineno">  294</span>&#160;    <span class="keywordflow">throw</span> <a class="code" href="classException_1_1NotImplementedException.html">Exception::NotImplementedException</a>( <span class="stringliteral">&quot;RecursiveGetPreOrder&quot;</span> ); <span class="comment">// Erase this once you work on this function</span></div>
<div class="line"><a name="l00295"></a><span class="lineno">  295</span>&#160;}</div>
<div class="line"><a name="l00296"></a><span class="lineno">  296</span>&#160; </div>
<div class="line"><a name="l00302"></a><span class="lineno">  302</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> TK, <span class="keyword">typename</span> TD&gt;</div>
<div class="line"><a name="l00303"></a><span class="lineno"><a class="line" href="classDataStructure_1_1BinarySearchTree.html#aad0331b880a93a1f5da7eafa54422c23">  303</a></span>&#160;std::string <a class="code" href="classDataStructure_1_1BinarySearchTree.html">BinarySearchTree&lt;TK,TD&gt;::GetPostOrder</a>()</div>
<div class="line"><a name="l00304"></a><span class="lineno">  304</span>&#160;{</div>
<div class="line"><a name="l00305"></a><span class="lineno">  305</span>&#160;<span class="comment">//    Utility::Logger::OutHighlight( &quot;FUNCTION BEGIN&quot;, &quot;BinarySearchTree&lt;TK,TD&gt;::GetPostOrder&quot; );</span></div>
<div class="line"><a name="l00306"></a><span class="lineno">  306</span>&#160;    std::stringstream stream;</div>
<div class="line"><a name="l00307"></a><span class="lineno">  307</span>&#160;    RecursiveGetPostOrder( m_ptrRoot, stream );</div>
<div class="line"><a name="l00308"></a><span class="lineno">  308</span>&#160;    <span class="keywordflow">return</span> stream.str();</div>
<div class="line"><a name="l00309"></a><span class="lineno">  309</span>&#160;}</div>
<div class="line"><a name="l00310"></a><span class="lineno">  310</span>&#160; </div>
<div class="line"><a name="l00320"></a><span class="lineno">  320</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> TK, <span class="keyword">typename</span> TD&gt;</div>
<div class="line"><a name="l00321"></a><span class="lineno"><a class="line" href="classDataStructure_1_1BinarySearchTree.html#af7ae1bff41e040651d457bff38e00f87">  321</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classDataStructure_1_1BinarySearchTree.html">BinarySearchTree&lt;TK,TD&gt;::RecursiveGetPostOrder</a>( <a class="code" href="classDataStructure_1_1BinarySearchTreeNode.html">BinarySearchTreeNode&lt;TK, TD&gt;</a>* ptrCurrent, std::stringstream&amp; stream )</div>
<div class="line"><a name="l00322"></a><span class="lineno">  322</span>&#160;{</div>
<div class="line"><a name="l00323"></a><span class="lineno">  323</span>&#160;    <span class="keywordflow">throw</span> <a class="code" href="classException_1_1NotImplementedException.html">Exception::NotImplementedException</a>( <span class="stringliteral">&quot;RecursiveGetPostOrder&quot;</span> ); <span class="comment">// Erase this once you work on this function</span></div>
<div class="line"><a name="l00324"></a><span class="lineno">  324</span>&#160;}</div>
<div class="line"><a name="l00325"></a><span class="lineno">  325</span>&#160; </div>
<div class="line"><a name="l00331"></a><span class="lineno">  331</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> TK, <span class="keyword">typename</span> TD&gt;</div>
<div class="line"><a name="l00332"></a><span class="lineno"><a class="line" href="classDataStructure_1_1BinarySearchTree.html#a16f629f10c23872f240c145d915a267d">  332</a></span>&#160;TK&amp; <a class="code" href="classDataStructure_1_1BinarySearchTree.html">BinarySearchTree&lt;TK,TD&gt;::GetMaxKey</a>()</div>
<div class="line"><a name="l00333"></a><span class="lineno">  333</span>&#160;{</div>
<div class="line"><a name="l00334"></a><span class="lineno">  334</span>&#160;    <span class="keywordflow">throw</span> <a class="code" href="classException_1_1NotImplementedException.html">Exception::NotImplementedException</a>( <span class="stringliteral">&quot;GetMaxKey&quot;</span> ); <span class="comment">// Erase this once you work on this function</span></div>
<div class="line"><a name="l00335"></a><span class="lineno">  335</span>&#160;}</div>
<div class="line"><a name="l00336"></a><span class="lineno">  336</span>&#160; </div>
<div class="line"><a name="l00349"></a><span class="lineno">  349</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> TK, <span class="keyword">typename</span> TD&gt;</div>
<div class="line"><a name="l00350"></a><span class="lineno"><a class="line" href="classDataStructure_1_1BinarySearchTree.html#a9068bcfbbff5dc93241a5faf980f6a78">  350</a></span>&#160;<a class="code" href="classDataStructure_1_1BinarySearchTreeNode.html">BinarySearchTreeNode&lt;TK, TD&gt;</a>* <a class="code" href="classDataStructure_1_1BinarySearchTree.html">BinarySearchTree&lt;TK,TD&gt;::RecursiveGetMax</a>( <a class="code" href="classDataStructure_1_1BinarySearchTreeNode.html">BinarySearchTreeNode&lt;TK, TD&gt;</a>* ptrCurrent )</div>
<div class="line"><a name="l00351"></a><span class="lineno">  351</span>&#160;{</div>
<div class="line"><a name="l00352"></a><span class="lineno">  352</span>&#160;    <span class="keywordflow">throw</span> <a class="code" href="classException_1_1NotImplementedException.html">Exception::NotImplementedException</a>( <span class="stringliteral">&quot;RecursiveGetMax&quot;</span> ); <span class="comment">// Erase this once you work on this function</span></div>
<div class="line"><a name="l00353"></a><span class="lineno">  353</span>&#160;}</div>
<div class="line"><a name="l00354"></a><span class="lineno">  354</span>&#160; </div>
<div class="line"><a name="l00360"></a><span class="lineno">  360</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> TK, <span class="keyword">typename</span> TD&gt;</div>
<div class="line"><a name="l00361"></a><span class="lineno"><a class="line" href="classDataStructure_1_1BinarySearchTree.html#afaa0ece8c510e5c850b85a6b72f1940d">  361</a></span>&#160;TK&amp; <a class="code" href="classDataStructure_1_1BinarySearchTree.html">BinarySearchTree&lt;TK,TD&gt;::GetMinKey</a>()</div>
<div class="line"><a name="l00362"></a><span class="lineno">  362</span>&#160;{</div>
<div class="line"><a name="l00363"></a><span class="lineno">  363</span>&#160;    <span class="keywordflow">throw</span> <a class="code" href="classException_1_1NotImplementedException.html">Exception::NotImplementedException</a>( <span class="stringliteral">&quot;GetMinKey&quot;</span> ); <span class="comment">// Erase this once you work on this function</span></div>
<div class="line"><a name="l00364"></a><span class="lineno">  364</span>&#160;}</div>
<div class="line"><a name="l00365"></a><span class="lineno">  365</span>&#160; </div>
<div class="line"><a name="l00366"></a><span class="lineno">  366</span>&#160; </div>
<div class="line"><a name="l00379"></a><span class="lineno">  379</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> TK, <span class="keyword">typename</span> TD&gt;</div>
<div class="line"><a name="l00380"></a><span class="lineno"><a class="line" href="classDataStructure_1_1BinarySearchTree.html#a9e3500de82a7bf93d64f92fc636277b1">  380</a></span>&#160;<a class="code" href="classDataStructure_1_1BinarySearchTreeNode.html">BinarySearchTreeNode&lt;TK, TD&gt;</a>* <a class="code" href="classDataStructure_1_1BinarySearchTree.html">BinarySearchTree&lt;TK,TD&gt;::RecursiveGetMin</a>( <a class="code" href="classDataStructure_1_1BinarySearchTreeNode.html">BinarySearchTreeNode&lt;TK, TD&gt;</a>* ptrCurrent )</div>
<div class="line"><a name="l00381"></a><span class="lineno">  381</span>&#160;{</div>
<div class="line"><a name="l00382"></a><span class="lineno">  382</span>&#160;    <span class="keywordflow">throw</span> <a class="code" href="classException_1_1NotImplementedException.html">Exception::NotImplementedException</a>( <span class="stringliteral">&quot;RecursiveGetMin&quot;</span> ); <span class="comment">// Erase this once you work on this function</span></div>
<div class="line"><a name="l00383"></a><span class="lineno">  383</span>&#160;}</div>
<div class="line"><a name="l00384"></a><span class="lineno">  384</span>&#160; </div>
<div class="line"><a name="l00390"></a><span class="lineno">  390</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> TK, <span class="keyword">typename</span> TD&gt;</div>
<div class="line"><a name="l00391"></a><span class="lineno"><a class="line" href="classDataStructure_1_1BinarySearchTree.html#a64651d83a65c70c091e497858f557ef1">  391</a></span>&#160;<span class="keywordtype">int</span> <a class="code" href="classDataStructure_1_1BinarySearchTree.html">BinarySearchTree&lt;TK,TD&gt;::GetCount</a>()     <span class="comment">// done</span></div>
<div class="line"><a name="l00392"></a><span class="lineno">  392</span>&#160;{</div>
<div class="line"><a name="l00393"></a><span class="lineno">  393</span>&#160;    <span class="keywordflow">return</span> m_nodeCount;</div>
<div class="line"><a name="l00394"></a><span class="lineno">  394</span>&#160;}</div>
<div class="line"><a name="l00395"></a><span class="lineno">  395</span>&#160; </div>
<div class="line"><a name="l00396"></a><span class="lineno">  396</span>&#160; </div>
<div class="line"><a name="l00403"></a><span class="lineno">  403</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> TK, <span class="keyword">typename</span> TD&gt;</div>
<div class="line"><a name="l00404"></a><span class="lineno"><a class="line" href="classDataStructure_1_1BinarySearchTree.html#ac190bb7d2872d4d2b844210bcd1cf589">  404</a></span>&#160;<a class="code" href="classDataStructure_1_1BinarySearchTreeNode.html">BinarySearchTreeNode&lt;TK, TD&gt;</a>* <a class="code" href="classDataStructure_1_1BinarySearchTree.html">BinarySearchTree&lt;TK,TD&gt;::FindNode</a>( <span class="keyword">const</span> TK&amp; key )</div>
<div class="line"><a name="l00405"></a><span class="lineno">  405</span>&#160;{</div>
<div class="line"><a name="l00406"></a><span class="lineno">  406</span>&#160;    <span class="keywordflow">throw</span> <a class="code" href="classException_1_1NotImplementedException.html">Exception::NotImplementedException</a>( <span class="stringliteral">&quot;FindNode&quot;</span> ); <span class="comment">// Erase this once you work on this function</span></div>
<div class="line"><a name="l00407"></a><span class="lineno">  407</span>&#160;}</div>
<div class="line"><a name="l00408"></a><span class="lineno">  408</span>&#160; </div>
<div class="line"><a name="l00409"></a><span class="lineno">  409</span>&#160; </div>
<div class="line"><a name="l00416"></a><span class="lineno">  416</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> TK, <span class="keyword">typename</span> TD&gt;</div>
<div class="line"><a name="l00417"></a><span class="lineno"><a class="line" href="classDataStructure_1_1BinarySearchTree.html#a35d7654273b21329e06097b5884afe61">  417</a></span>&#160;<span class="keywordtype">int</span> <a class="code" href="classDataStructure_1_1BinarySearchTree.html">BinarySearchTree&lt;TK,TD&gt;::GetHeight</a>()</div>
<div class="line"><a name="l00418"></a><span class="lineno">  418</span>&#160;{</div>
<div class="line"><a name="l00419"></a><span class="lineno">  419</span>&#160;    <span class="keywordflow">throw</span> <a class="code" href="classException_1_1NotImplementedException.html">Exception::NotImplementedException</a>( <span class="stringliteral">&quot;GetHeight&quot;</span> ); <span class="comment">// Erase this once you work on this function</span></div>
<div class="line"><a name="l00420"></a><span class="lineno">  420</span>&#160;}</div>
<div class="line"><a name="l00421"></a><span class="lineno">  421</span>&#160; </div>
<div class="line"><a name="l00432"></a><span class="lineno">  432</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> TK, <span class="keyword">typename</span> TD&gt;</div>
<div class="line"><a name="l00433"></a><span class="lineno"><a class="line" href="classDataStructure_1_1BinarySearchTree.html#a4cf22a623f3265f82ec025058caa80a5">  433</a></span>&#160;<span class="keywordtype">int</span> <a class="code" href="classDataStructure_1_1BinarySearchTree.html">BinarySearchTree&lt;TK,TD&gt;::RecursiveGetHeight</a>( <a class="code" href="classDataStructure_1_1BinarySearchTreeNode.html">BinarySearchTreeNode&lt;TK, TD&gt;</a>* ptrCurrent )</div>
<div class="line"><a name="l00434"></a><span class="lineno">  434</span>&#160;{</div>
<div class="line"><a name="l00435"></a><span class="lineno">  435</span>&#160;    <span class="keywordflow">throw</span> <a class="code" href="classException_1_1NotImplementedException.html">Exception::NotImplementedException</a>( <span class="stringliteral">&quot;RecursiveGetHeight&quot;</span> ); <span class="comment">// Erase this once you work on this function</span></div>
<div class="line"><a name="l00436"></a><span class="lineno">  436</span>&#160;}</div>
<div class="line"><a name="l00437"></a><span class="lineno">  437</span>&#160; </div>
<div class="line"><a name="l00446"></a><span class="lineno">  446</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> TK, <span class="keyword">typename</span> TD&gt;</div>
<div class="line"><a name="l00447"></a><span class="lineno"><a class="line" href="classDataStructure_1_1BinarySearchTree.html#a616fe60e0b95d4a4910c9daf22f8f091">  447</a></span>&#160;TD&amp; <a class="code" href="classDataStructure_1_1BinarySearchTree.html">BinarySearchTree&lt;TK,TD&gt;::GetData</a>( <span class="keyword">const</span> TK&amp; key )</div>
<div class="line"><a name="l00448"></a><span class="lineno">  448</span>&#160;{</div>
<div class="line"><a name="l00449"></a><span class="lineno">  449</span>&#160;    <span class="keywordflow">throw</span> <a class="code" href="classException_1_1NotImplementedException.html">Exception::NotImplementedException</a>( <span class="stringliteral">&quot;GetData&quot;</span> ); <span class="comment">// Erase this once you work on this function</span></div>
<div class="line"><a name="l00450"></a><span class="lineno">  450</span>&#160;}</div>
<div class="line"><a name="l00451"></a><span class="lineno">  451</span>&#160; </div>
<div class="line"><a name="l00452"></a><span class="lineno">  452</span>&#160;<span class="comment">/* **************************************************************************************** */</span></div>
<div class="line"><a name="l00453"></a><span class="lineno">  453</span>&#160;<span class="comment">/* ****************************************************** Deletion functions (already done) */</span></div>
<div class="line"><a name="l00454"></a><span class="lineno">  454</span>&#160;<span class="comment">/* **************************************************************************************** */</span></div>
<div class="line"><a name="l00455"></a><span class="lineno">  455</span>&#160; </div>
<div class="line"><a name="l00462"></a><span class="lineno">  462</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> TK, <span class="keyword">typename</span> TD&gt;</div>
<div class="line"><a name="l00463"></a><span class="lineno"><a class="line" href="classDataStructure_1_1BinarySearchTree.html#aa76af5cc4dffce8274d99c53b01259ca">  463</a></span>&#160;TD&amp; <a class="code" href="classDataStructure_1_1BinarySearchTree.html">BinarySearchTree&lt;TK, TD&gt;::GetRoot</a>()</div>
<div class="line"><a name="l00464"></a><span class="lineno">  464</span>&#160;{</div>
<div class="line"><a name="l00465"></a><span class="lineno">  465</span>&#160;    <span class="keywordflow">if</span> (m_ptrRoot == <span class="keyword">nullptr</span>) { <span class="keywordflow">throw</span> runtime_error(<span class="stringliteral">&quot;Tree is empty!&quot;</span>); }</div>
<div class="line"><a name="l00466"></a><span class="lineno">  466</span>&#160;    <span class="keywordflow">return</span> m_ptrRoot-&gt;data;</div>
<div class="line"><a name="l00467"></a><span class="lineno">  467</span>&#160;}</div>
<div class="line"><a name="l00468"></a><span class="lineno">  468</span>&#160; </div>
<div class="line"><a name="l00469"></a><span class="lineno">  469</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> TK, <span class="keyword">typename</span> TD&gt;</div>
<div class="line"><a name="l00470"></a><span class="lineno"><a class="line" href="classDataStructure_1_1BinarySearchTree.html#afa25866546d8f5b0abeebf3fabe5f0ba">  470</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classDataStructure_1_1BinarySearchTree.html">BinarySearchTree&lt;TK, TD&gt;::PopRoot</a>()</div>
<div class="line"><a name="l00471"></a><span class="lineno">  471</span>&#160;{</div>
<div class="line"><a name="l00472"></a><span class="lineno">  472</span>&#160;    PopNode(m_ptrRoot);</div>
<div class="line"><a name="l00473"></a><span class="lineno">  473</span>&#160;}</div>
<div class="line"><a name="l00474"></a><span class="lineno">  474</span>&#160; </div>
<div class="line"><a name="l00475"></a><span class="lineno">  475</span>&#160;<span class="comment">// https://en.wikipedia.org/wiki/Binary_search_tree#Deletion</span></div>
<div class="line"><a name="l00476"></a><span class="lineno">  476</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> TK, <span class="keyword">typename</span> TD&gt;</div>
<div class="line"><a name="l00477"></a><span class="lineno"><a class="line" href="classDataStructure_1_1BinarySearchTree.html#acdff041da5aa4e72e7c77e8d735c1bbf">  477</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classDataStructure_1_1BinarySearchTree.html">BinarySearchTree&lt;TK, TD&gt;::PopNode</a>(<a class="code" href="classDataStructure_1_1BinarySearchTreeNode.html">BinarySearchTreeNode&lt;TK, TD&gt;</a>* ptrCurrent)</div>
<div class="line"><a name="l00478"></a><span class="lineno">  478</span>&#160;{</div>
<div class="line"><a name="l00479"></a><span class="lineno">  479</span>&#160;    <span class="keywordflow">if</span> (m_ptrRoot-&gt;ptrLeft == <span class="keyword">nullptr</span>)</div>
<div class="line"><a name="l00480"></a><span class="lineno">  480</span>&#160;    {</div>
<div class="line"><a name="l00481"></a><span class="lineno">  481</span>&#160;        ShiftNodes(ptrCurrent, ptrCurrent-&gt;<a class="code" href="classDataStructure_1_1BinarySearchTreeNode.html#aee9e5e5fce49d108070b08ca86263245">ptrRight</a>);</div>
<div class="line"><a name="l00482"></a><span class="lineno">  482</span>&#160;    }</div>
<div class="line"><a name="l00483"></a><span class="lineno">  483</span>&#160;    <span class="keywordflow">else</span> <span class="keywordflow">if</span> (m_ptrRoot-&gt;ptrRight == <span class="keyword">nullptr</span>)</div>
<div class="line"><a name="l00484"></a><span class="lineno">  484</span>&#160;    {</div>
<div class="line"><a name="l00485"></a><span class="lineno">  485</span>&#160;        ShiftNodes(ptrCurrent, ptrCurrent-&gt;<a class="code" href="classDataStructure_1_1BinarySearchTreeNode.html#a7a9931ebf665beb4334375980ea1c2bb">ptrLeft</a>);</div>
<div class="line"><a name="l00486"></a><span class="lineno">  486</span>&#160;    }</div>
<div class="line"><a name="l00487"></a><span class="lineno">  487</span>&#160;    <span class="keywordflow">else</span></div>
<div class="line"><a name="l00488"></a><span class="lineno">  488</span>&#160;    {</div>
<div class="line"><a name="l00489"></a><span class="lineno">  489</span>&#160;        <a class="code" href="classDataStructure_1_1BinarySearchTreeNode.html">BinarySearchTreeNode&lt;TK, TD&gt;</a>* ptrSuccessor = GetSuccessor(ptrCurrent);</div>
<div class="line"><a name="l00490"></a><span class="lineno">  490</span>&#160;        <span class="keywordflow">if</span> (ptrSuccessor-&gt;<a class="code" href="classDataStructure_1_1BinarySearchTreeNode.html#a305fb5a054cf1b1a840b8c79cbce955a">ptrParent</a> != ptrCurrent)</div>
<div class="line"><a name="l00491"></a><span class="lineno">  491</span>&#160;        {</div>
<div class="line"><a name="l00492"></a><span class="lineno">  492</span>&#160;            ShiftNodes(ptrSuccessor, ptrSuccessor-&gt;<a class="code" href="classDataStructure_1_1BinarySearchTreeNode.html#aee9e5e5fce49d108070b08ca86263245">ptrRight</a>);</div>
<div class="line"><a name="l00493"></a><span class="lineno">  493</span>&#160;            ptrSuccessor-&gt;<a class="code" href="classDataStructure_1_1BinarySearchTreeNode.html#aee9e5e5fce49d108070b08ca86263245">ptrRight</a> = ptrCurrent-&gt;<a class="code" href="classDataStructure_1_1BinarySearchTreeNode.html#aee9e5e5fce49d108070b08ca86263245">ptrRight</a>;</div>
<div class="line"><a name="l00494"></a><span class="lineno">  494</span>&#160;            ptrSuccessor-&gt;<a class="code" href="classDataStructure_1_1BinarySearchTreeNode.html#aee9e5e5fce49d108070b08ca86263245">ptrRight</a>-&gt;ptrParent = ptrSuccessor;</div>
<div class="line"><a name="l00495"></a><span class="lineno">  495</span>&#160;        }</div>
<div class="line"><a name="l00496"></a><span class="lineno">  496</span>&#160; </div>
<div class="line"><a name="l00497"></a><span class="lineno">  497</span>&#160;        ShiftNodes(ptrCurrent, ptrSuccessor);</div>
<div class="line"><a name="l00498"></a><span class="lineno">  498</span>&#160;        ptrSuccessor-&gt;<a class="code" href="classDataStructure_1_1BinarySearchTreeNode.html#a7a9931ebf665beb4334375980ea1c2bb">ptrLeft</a> = ptrCurrent-&gt;<a class="code" href="classDataStructure_1_1BinarySearchTreeNode.html#a7a9931ebf665beb4334375980ea1c2bb">ptrLeft</a>;</div>
<div class="line"><a name="l00499"></a><span class="lineno">  499</span>&#160;        ptrSuccessor-&gt;<a class="code" href="classDataStructure_1_1BinarySearchTreeNode.html#a7a9931ebf665beb4334375980ea1c2bb">ptrLeft</a>-&gt;ptrParent = ptrSuccessor;</div>
<div class="line"><a name="l00500"></a><span class="lineno">  500</span>&#160;    }</div>
<div class="line"><a name="l00501"></a><span class="lineno">  501</span>&#160; </div>
<div class="line"><a name="l00502"></a><span class="lineno">  502</span>&#160;    m_nodeCount--;</div>
<div class="line"><a name="l00503"></a><span class="lineno">  503</span>&#160;}</div>
<div class="line"><a name="l00504"></a><span class="lineno">  504</span>&#160; </div>
<div class="line"><a name="l00505"></a><span class="lineno">  505</span>&#160;<span class="comment">// https://en.wikipedia.org/wiki/Binary_search_tree#Deletion</span></div>
<div class="line"><a name="l00506"></a><span class="lineno">  506</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> TK, <span class="keyword">typename</span> TD&gt;</div>
<div class="line"><a name="l00507"></a><span class="lineno"><a class="line" href="classDataStructure_1_1BinarySearchTree.html#a459c979a497014e725f20e0584eefe97">  507</a></span>&#160;<span class="keywordtype">void</span> <a class="code" href="classDataStructure_1_1BinarySearchTree.html">BinarySearchTree&lt;TK, TD&gt;::ShiftNodes</a>(<a class="code" href="classDataStructure_1_1BinarySearchTreeNode.html">BinarySearchTreeNode&lt;TK, TD&gt;</a>* node1, <a class="code" href="classDataStructure_1_1BinarySearchTreeNode.html">BinarySearchTreeNode&lt;TK, TD&gt;</a>* node2)</div>
<div class="line"><a name="l00508"></a><span class="lineno">  508</span>&#160;{</div>
<div class="line"><a name="l00509"></a><span class="lineno">  509</span>&#160;    <span class="keywordflow">if</span> (node1-&gt;<a class="code" href="classDataStructure_1_1BinarySearchTreeNode.html#a305fb5a054cf1b1a840b8c79cbce955a">ptrParent</a> == <span class="keyword">nullptr</span>)</div>
<div class="line"><a name="l00510"></a><span class="lineno">  510</span>&#160;    {</div>
<div class="line"><a name="l00511"></a><span class="lineno">  511</span>&#160;        m_ptrRoot = node2;</div>
<div class="line"><a name="l00512"></a><span class="lineno">  512</span>&#160;    }</div>
<div class="line"><a name="l00513"></a><span class="lineno">  513</span>&#160;    <span class="keywordflow">else</span> <span class="keywordflow">if</span> (node1 == node1-&gt;<a class="code" href="classDataStructure_1_1BinarySearchTreeNode.html#a305fb5a054cf1b1a840b8c79cbce955a">ptrParent</a>-&gt;ptrLeft)</div>
<div class="line"><a name="l00514"></a><span class="lineno">  514</span>&#160;    {</div>
<div class="line"><a name="l00515"></a><span class="lineno">  515</span>&#160;        node1-&gt;<a class="code" href="classDataStructure_1_1BinarySearchTreeNode.html#a305fb5a054cf1b1a840b8c79cbce955a">ptrParent</a>-&gt;ptrLeft = node2;</div>
<div class="line"><a name="l00516"></a><span class="lineno">  516</span>&#160;    }</div>
<div class="line"><a name="l00517"></a><span class="lineno">  517</span>&#160;    <span class="keywordflow">else</span></div>
<div class="line"><a name="l00518"></a><span class="lineno">  518</span>&#160;    {</div>
<div class="line"><a name="l00519"></a><span class="lineno">  519</span>&#160;        node1-&gt;<a class="code" href="classDataStructure_1_1BinarySearchTreeNode.html#a305fb5a054cf1b1a840b8c79cbce955a">ptrParent</a>-&gt;ptrRight = node2;</div>
<div class="line"><a name="l00520"></a><span class="lineno">  520</span>&#160;    }</div>
<div class="line"><a name="l00521"></a><span class="lineno">  521</span>&#160; </div>
<div class="line"><a name="l00522"></a><span class="lineno">  522</span>&#160;    <span class="keywordflow">if</span> (node2 != <span class="keyword">nullptr</span>)</div>
<div class="line"><a name="l00523"></a><span class="lineno">  523</span>&#160;    {</div>
<div class="line"><a name="l00524"></a><span class="lineno">  524</span>&#160;        node2-&gt;<a class="code" href="classDataStructure_1_1BinarySearchTreeNode.html#a305fb5a054cf1b1a840b8c79cbce955a">ptrParent</a> = node1-&gt;<a class="code" href="classDataStructure_1_1BinarySearchTreeNode.html#a305fb5a054cf1b1a840b8c79cbce955a">ptrParent</a>;</div>
<div class="line"><a name="l00525"></a><span class="lineno">  525</span>&#160;    }</div>
<div class="line"><a name="l00526"></a><span class="lineno">  526</span>&#160;}</div>
<div class="line"><a name="l00527"></a><span class="lineno">  527</span>&#160; </div>
<div class="line"><a name="l00528"></a><span class="lineno">  528</span>&#160;<span class="comment">// https://en.wikipedia.org/wiki/Binary_search_tree#Successor_and_predecessor</span></div>
<div class="line"><a name="l00529"></a><span class="lineno">  529</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">typename</span> TK, <span class="keyword">typename</span> TD&gt;</div>
<div class="line"><a name="l00530"></a><span class="lineno"><a class="line" href="classDataStructure_1_1BinarySearchTree.html#aaf387bdd98abf4d87263a2c4b5eab54f">  530</a></span>&#160;<a class="code" href="classDataStructure_1_1BinarySearchTreeNode.html">BinarySearchTreeNode&lt;TK, TD&gt;</a>* <a class="code" href="classDataStructure_1_1BinarySearchTree.html">BinarySearchTree&lt;TK, TD&gt;::GetSuccessor</a>(<a class="code" href="classDataStructure_1_1BinarySearchTreeNode.html">BinarySearchTreeNode&lt;TK, TD&gt;</a>* ptrCurrent)</div>
<div class="line"><a name="l00531"></a><span class="lineno">  531</span>&#160;{</div>
<div class="line"><a name="l00532"></a><span class="lineno">  532</span>&#160;    <span class="keywordflow">if</span> (ptrCurrent-&gt;<a class="code" href="classDataStructure_1_1BinarySearchTreeNode.html#aee9e5e5fce49d108070b08ca86263245">ptrRight</a> != <span class="keyword">nullptr</span>)</div>
<div class="line"><a name="l00533"></a><span class="lineno">  533</span>&#160;    {</div>
<div class="line"><a name="l00534"></a><span class="lineno">  534</span>&#160;        <span class="keywordflow">return</span> RecursiveGetMin(ptrCurrent-&gt;<a class="code" href="classDataStructure_1_1BinarySearchTreeNode.html#aee9e5e5fce49d108070b08ca86263245">ptrRight</a>);</div>
<div class="line"><a name="l00535"></a><span class="lineno">  535</span>&#160;    }</div>
<div class="line"><a name="l00536"></a><span class="lineno">  536</span>&#160; </div>
<div class="line"><a name="l00537"></a><span class="lineno">  537</span>&#160;    <a class="code" href="classDataStructure_1_1BinarySearchTreeNode.html">BinarySearchTreeNode&lt;TK, TD&gt;</a>* ptrPrevious = ptrCurrent-&gt;<a class="code" href="classDataStructure_1_1BinarySearchTreeNode.html#a305fb5a054cf1b1a840b8c79cbce955a">ptrParent</a>;</div>
<div class="line"><a name="l00538"></a><span class="lineno">  538</span>&#160;    <span class="keywordflow">while</span> (ptrPrevious != <span class="keyword">nullptr</span> &amp;&amp; ptrCurrent == ptrPrevious-&gt;<a class="code" href="classDataStructure_1_1BinarySearchTreeNode.html#aee9e5e5fce49d108070b08ca86263245">ptrRight</a>)</div>
<div class="line"><a name="l00539"></a><span class="lineno">  539</span>&#160;    {</div>
<div class="line"><a name="l00540"></a><span class="lineno">  540</span>&#160;        ptrCurrent = ptrPrevious;</div>
<div class="line"><a name="l00541"></a><span class="lineno">  541</span>&#160;        ptrPrevious = ptrCurrent-&gt;<a class="code" href="classDataStructure_1_1BinarySearchTreeNode.html#a305fb5a054cf1b1a840b8c79cbce955a">ptrParent</a>;</div>
<div class="line"><a name="l00542"></a><span class="lineno">  542</span>&#160;    }</div>
<div class="line"><a name="l00543"></a><span class="lineno">  543</span>&#160; </div>
<div class="line"><a name="l00544"></a><span class="lineno">  544</span>&#160;    <span class="keywordflow">return</span> ptrPrevious;</div>
<div class="line"><a name="l00545"></a><span class="lineno">  545</span>&#160;}</div>
<div class="line"><a name="l00546"></a><span class="lineno">  546</span>&#160; </div>
<div class="line"><a name="l00547"></a><span class="lineno">  547</span>&#160;} <span class="comment">// End namespace</span></div>
<div class="line"><a name="l00548"></a><span class="lineno">  548</span>&#160; </div>
<div class="line"><a name="l00549"></a><span class="lineno">  549</span>&#160;<span class="preprocessor">#endif</span></div>
</div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="aclassDataStructure_1_1BinarySearchTreeNode_html_aee9e5e5fce49d108070b08ca86263245"><div class="ttname"><a href="classDataStructure_1_1BinarySearchTreeNode.html#aee9e5e5fce49d108070b08ca86263245">DataStructure::BinarySearchTreeNode::ptrRight</a></div><div class="ttdeci">BinarySearchTreeNode&lt; TK, TD &gt; * ptrRight</div><div class="ttdoc">Pointer to the right chlid of the node, which is greater in value.</div><div class="ttdef"><b>Definition:</b> BinarySearchTreeNode.h:45</div></div>
<div class="ttc" id="aBinarySearchTreeNode_8h_html"><div class="ttname"><a href="BinarySearchTreeNode_8h.html">BinarySearchTreeNode.h</a></div></div>
<div class="ttc" id="aclassDataStructure_1_1BinarySearchTree_html_a483543c8214d622bb7b820ba23b40df6"><div class="ttname"><a href="classDataStructure_1_1BinarySearchTree.html#a483543c8214d622bb7b820ba23b40df6">DataStructure::BinarySearchTree::m_nodeCount</a></div><div class="ttdeci">int m_nodeCount</div><div class="ttdoc">The amount of nodes in the tree.</div><div class="ttdef"><b>Definition:</b> BinarySearchTree.h:24</div></div>
<div class="ttc" id="aclassDataStructure_1_1BinarySearchTreeNode_html_a7a9931ebf665beb4334375980ea1c2bb"><div class="ttname"><a href="classDataStructure_1_1BinarySearchTreeNode.html#a7a9931ebf665beb4334375980ea1c2bb">DataStructure::BinarySearchTreeNode::ptrLeft</a></div><div class="ttdeci">BinarySearchTreeNode&lt; TK, TD &gt; * ptrLeft</div><div class="ttdoc">Pointer to the left child of the node, which is lesser in value.</div><div class="ttdef"><b>Definition:</b> BinarySearchTreeNode.h:42</div></div>
<div class="ttc" id="aclassDataStructure_1_1BinarySearchTreeNode_html"><div class="ttname"><a href="classDataStructure_1_1BinarySearchTreeNode.html">DataStructure::BinarySearchTreeNode</a></div><div class="ttdoc">A template node class, to be used in the BinarySearchTree class.</div><div class="ttdef"><b>Definition:</b> BinarySearchTreeNode.h:13</div></div>
<div class="ttc" id="aclassDataStructure_1_1BinarySearchTree_html"><div class="ttname"><a href="classDataStructure_1_1BinarySearchTree.html">DataStructure::BinarySearchTree</a></div><div class="ttdoc">A template binary search tree class that takes a KEY and a DATA.</div><div class="ttdef"><b>Definition:</b> BinarySearchTree.h:17</div></div>
<div class="ttc" id="aclassDataStructure_1_1BinarySearchTreeTester_html"><div class="ttname"><a href="classDataStructure_1_1BinarySearchTreeTester.html">DataStructure::BinarySearchTreeTester</a></div><div class="ttdoc">TESTER for the BinarySearchTree.</div><div class="ttdef"><b>Definition:</b> BinarySearchTreeTester.h:22</div></div>
<div class="ttc" id="aclassDataStructure_1_1BinarySearchTree_html_a3c6a9c70728ff0309cbcc02d47c06433"><div class="ttname"><a href="classDataStructure_1_1BinarySearchTree.html#a3c6a9c70728ff0309cbcc02d47c06433">DataStructure::BinarySearchTree::m_ptrRoot</a></div><div class="ttdeci">BinarySearchTreeNode&lt; TK, TD &gt; * m_ptrRoot</div><div class="ttdoc">A pointer to the root node of the tree; TK = data type of the key, TD = data type of the data.</div><div class="ttdef"><b>Definition:</b> BinarySearchTree.h:21</div></div>
<div class="ttc" id="anamespaceDataStructure_html"><div class="ttname"><a href="namespaceDataStructure.html">DataStructure</a></div><div class="ttdef"><b>Definition:</b> BinarySearchTree.h:12</div></div>
<div class="ttc" id="aclassException_1_1NotImplementedException_html"><div class="ttname"><a href="classException_1_1NotImplementedException.html">Exception::NotImplementedException</a></div><div class="ttdoc">EXCEPTION for when a function has not yet been implemented.</div><div class="ttdef"><b>Definition:</b> NotImplementedException.h:12</div></div>
<div class="ttc" id="aclassUtility_1_1Logger_html_a084fbcd19701dc0b69c7549bef4c667f"><div class="ttname"><a href="classUtility_1_1Logger.html#a084fbcd19701dc0b69c7549bef4c667f">Utility::Logger::OutHighlight</a></div><div class="ttdeci">static void OutHighlight(const std::string &amp;message, const std::string &amp;location=&quot;&quot;, int color=1)</div><div class="ttdoc">Highlights a log entry.</div><div class="ttdef"><b>Definition:</b> Logger.cpp:93</div></div>
<div class="ttc" id="aclassDataStructure_1_1BinarySearchTreeNode_html_a305fb5a054cf1b1a840b8c79cbce955a"><div class="ttname"><a href="classDataStructure_1_1BinarySearchTreeNode.html#a305fb5a054cf1b1a840b8c79cbce955a">DataStructure::BinarySearchTreeNode::ptrParent</a></div><div class="ttdeci">BinarySearchTreeNode&lt; TK, TD &gt; * ptrParent</div><div class="ttdoc">Pointer to the parent node of this node.</div><div class="ttdef"><b>Definition:</b> BinarySearchTreeNode.h:48</div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.17
</small></address>
</body>
</html>
